from collections import Counter
import matplotlib.pyplot as plt
import numpy as np
from tmp_samples import samples

median = np.percentile(samples, 50)
upper_perc = np.percentile(samples, 99)

cnt = Counter(samples) # count occurences of sampled signature sizes
cnt = sorted(cnt.items(), key=lambda pair: pair[0])

names = []
values = []

for a, b in cnt:
    names.append(a)
    values.append(b)
    print(f"{a} {b}")

print(f'Median: {median}, 99th Percentile: {upper_perc} based on {len(samples)} sample values\n')

plt.bar(range(len(cnt)), values, tick_label=names)
plt.xticks(rotation=45)
title = f'Median: {median}, 99th Percentile: {upper_perc}'
plt.title(title)
plt.savefig('sigsize.png')