from collections import Counter
import math
import numpy as np
import sys
from tmp_samples import samples

SCALE = 1024
SCALE_FACTOR = SCALE/len(samples)
HAETAE_MODE = 2

argument = 'h2'
if len(sys.argv) == 2:
    argument = sys.argv[1]

if argument == 'z2':
    M = 13  # symbol space for the encoding of hb_z1 for Haetae 2
elif argument == 'z3':
    M = 17 # symbol space for the encoding of hb_z1 for Haetae 3
elif argument == 'z5':
    M = 19 # symbol space for the encoding of hb_z1 for Haetae 5
elif argument == 'h2':
    M = 13  # symbol space for the encoding of h for Haetae 2
elif argument == 'h3':
    M = 17  # symbol space for the encoding of h for Haetae 3
elif argument == 'h5':
    M = 33 # symbol space for the encoding of h for Haetae 5
else:
    M = 13 # symbol space for the encoding of h for Haetae 2

freq = np.zeros(M) # init frequency of each symbol with 0

cnt = Counter(samples) # count occurences of sampled symbols

for i in range(M):
    freq[i] = cnt[i]

freq = freq * SCALE_FACTOR
freq = np.array([round(x) for x in freq]) # round to integer value
freq[freq == 0] = 1 # freq must be at least 1

sum = np.sum(freq)
diff = sum - SCALE
freq[np.argmax(freq)] -= diff

print(f'Frequency table for rANS encoding of {argument} with {M} different symbols, scale is {SCALE}')
print("based on", str(len(samples)), "sample values, the difference was:", str(diff),"\n" )

out = "["
for f in freq:
    out += f'{f}, '
out += "]"
print(out)